module PeppersGhost::Matchers
  matcher :match_resource do |expected, type|
    chain :strictly do
      @strict = true
    end

    match do |actual|
      begin
        resource = PeppersGhost.ghost_for(type)
        match_resource_type actual, expected, resource.attributes, @strict
      rescue RSpec::Expectations::ExpectationNotMetError => e
        @error = e.message
        false
      end
    end

    failure_message_for_should do
      @error
    end
  end
end
