require 'rspec'

module PeppersGhost
end

require_relative 'peppers-ghost/core'

require_relative 'peppers-ghost/ghost'
require_relative 'peppers-ghost/ghost_factory'

require_relative 'peppers-ghost/shared/json_context'
require_relative 'peppers-ghost/shared/list_example'

require_relative 'peppers-ghost/matchers'
require_relative 'peppers-ghost/matchers/match_structure_of'
require_relative 'peppers-ghost/matchers/match_resource'

module PeppersGhost
  extend PeppersGhost::GhostFactory
end

RSpec.configure do |config|
  config.include PeppersGhost::Core
  config.include PeppersGhost::Matchers
end
